/*
Programm: Aufg.AusdrAnalyse
Zweck:    Verarbeitung vollstndig geklammerter Ausdrcke
Aufgabe:  Entspricht dem Punkt "8.9.5 Aufgabe 5" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-10
*/

#include <iostream> 
#include <string> 

using namespace std; 

int ausdruckWert (string, int &); 
bool istZiffer (char); 
int zahlWert (string, int &); 
int anwende (char, int, int);
void skipspace (string, int &);

int main () { 
   string a; //Eingelesene Zeichenkette 
   int pos = 0; //Start des zu bestimmenden Ausdrucks 
   getline(cin,a); 
   cout << ausdruckWert (a, pos); 
   cout << endl; 
} 

int ausdruckWert (string zeichen, int &pos) {
   // ein Ausdruck kann mit Leerzeichen beginnen:
   skipspace(zeichen, pos);
   if (istZiffer(zeichen.at(pos))) { // beginnt mit Ziffer? Eine Zahl!:
      int zahl = zahlWert(zeichen, pos); 
      // ein Ausdruck kann mit Leerzeichen enden:
      skipspace(zeichen, pos);
      return zahl;
   } 
   else 
      if (zeichen.at(pos) ==  '(' ) { 
         int v1, v2, res; 
	 char op; 
	 ++pos; 
	 v1 = ausdruckWert (zeichen, pos); 
	 op = zeichen.at(pos); 
	 ++pos; 
	 v2 = ausdruckWert (zeichen, pos); 
	 res = anwende (op, v1, v2); 
	 if (pos < (zeichen.length()-1)) ++pos; // ) 
         // ein Ausdruck kann mit Leerzeichen enden:
         skipspace(zeichen,pos); 
         return res; 
      } 
   cout << "Ausdruck ist nicht OK an pos " << pos << " : ( erwartet \n"; 
   return -99; 
} 

bool istZiffer (char c) { 
   return (c >= '0' && c <= '9'); 
} 

int zahlWert (string zeichen, int &pos) { 
   int f=0;
   while (istZiffer(zeichen.at(pos))) {
      f= f*10 + (zeichen.at(pos) - '0');
      ++pos;
   }
   return f;
} 

int anwende (char op, int v1, int v2) { 
   switch (op) { 
      case  '+' : return v1 + v2; 
      case  '-' : return v1 - v2; 
      case  '*' : return v1 * v2; 
      case  '/' : return v1 / v2; 
      default: cout << "Ausdruck ist nicht OK, Operator +-*/ erwartet! \n"; 
   } 
   return -99; 
}

void skipspace (string zeichen, int &pos) {
   while (zeichen.at(pos)==' ') {
      ++pos;
   }
}
