/*
Programm: Aufg.GaussSchema
Zweck:    Gauss-Elimination
Aufgabe:  Entspricht dem Punkt "8.9.3 Aufgabe 3" Punkt 5 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-09
*/


#include <iostream> 
using namespace std; 

const int N = 3; 
typedef float Zeile[N]; 
typedef Zeile Matrix[N]; 
typedef float Vektor[N]; 

// Die Gleichungen im Gauss-Schema:
Matrix a; // Vektor mit Linearkombinationen der Unbekannten
Vektor b; // Ergebnisspalten-Vektor

// Hilfsvariablen zum Zeilentausch
float hilf;

// Ergebnisvektor der Unbekannten
Vektor x;

int r; // Index einer geeigneten nchsten Zeile

int main () { 
   float f; // Faktor, mit dem eine Gleichung vor der 
            // Subtraktion erweitert wird

   // Eingabe von a und b
   for (int i=0; i<N; ++i) { // eine Zeile einlesen
      cout << "Bitte " << i+1 << ". Zeile eingeben (" << N 
	   << " Koeffizienten, 1 Ergebnis; Leerzeichentrennung):\n";
      for (int j=0; j<N; ++j) 
	 cin >> a[i][j];
      cin >> b[i];
   }

   // In obere Dreiecksform bringen:
   for (int i = 0; i < N; ++i) { // fuer jede Zeile tue ...

      // geeignete Gleichung suchen: suche eine Zeile Nr.r 
      // mit r>=i, a[r][i]!=0 und tausche die mit der aktuellen
      // Gleichung i
      
      for (r=i; r<N; ++r) 
	 if (a[r][i]!=0) break;
   
      // Wenn die Schleife nicht mit break verlassen wurde
      // (es also keine passende Zeile gibt) ist jetzt r==N:
      if (r==N) {
	 cout << "Das Gleichungssystem ist nicht eindeutig lsbar.\n.";
	 return 1;  // Fehlerstatus "Nicht eindeutig lsbar"
      }
      
      // Tausche die Zeilen a[i][] mit a[r][]
      if (r!=i) {
	 for (int k=0; k<N; ++k) {
	    hilf=a[i][k];
	    a[i][k]=a[r][k];
	    a[r][k]=hilf;
	 }
	 hilf=b[i];
	 b[i]=b[r];
	 b[r]=hilf;
      }
      
      for (int j = i+1; j < N; ++j) { // fuer jede folgende Zeile tue ...
	 f = a[j][i]/a[i][i]; 
	 for (int m = i; m<N; ++m) 
	    a[j][m] = a[j][m] - f*a[i][m]; 
	 b[j] = b[j] - f*b[i];
      } 
   }
   //Rueckrechnung (x-Werte berechnen): 
   for (int i = N-1; i>=0; --i) { 
      float z = b[i]; 
      for (int j=i+1; j<N; ++j) 
	 z = z - x[j]*a[i][j]; 
      x[i] = z/a[i][i]; 
   } 

   // Ausgabe von x
   cout << endl << endl;
   for (int i=0; i<N; ++i) 
      cout << i+1 << ". Unbekannte: " << x[i] << endl;
}

