/*
Programm: Aufg.N_ueber_K
Zweck:    tabellarisch Berechnung von "n ueber k" mit dem Pascalschen Dreieck
Aufgabe:  Entspricht dem Punkt "5.9.4 Aufgabe 4" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-02
*/


#include <iostream>
using namespace std;

int main () {
   const int N=20;  // wieviele Zeilen der "n ueber k"-Tabelle
   const int K=20;  // wieviele Spalten der "n ueber k"-Tabelle

   typedef int   Zeile[K];
   typedef Zeile Tabelle[N];

   Tabelle tab;
   int     n,
           k;

   // Startwerte 1. Zeile
   for (int i=1; i<K; ++i) {
      tab[0][i]=0;
   }
   
   // Startwerte 1. Spalte
   for (int i=0; i<N; ++i) {
      tab[i][0]=1;
   }
   
   // Kalkulation der "n ueber k"-Tabelle
   for (int i=1; i<N; ++i) {
      for (int j=1; j<K; ++j) {
         tab[i][j] = tab[i-1][j-1] + tab[i-1][j];
      }
   }
  
   // Ausgabe an eines Wertes "n ueber k" aus der Tabelle
   cout << "0 <= n < " << N-1 << " eingeben: ";
   cin >> n;
   cout << "0 <= k < " << K-1 << " eingeben: ";
   cin >> k;
   cout << "(n ueber k) ist: " << tab[n][k] << endl; 
} 
