/*
Programm: Aufg.Summe2iInduktion
Zweck:    Berechnet die Summe von i=0..n ber 2*i zur experimentellen
          Prfung der Formel 2^0 + 2^1 + .. + 2^n = 2^(n-1) - 1
Aufgabe:  Entspricht dem Punkt "3.10.7 Aufgabe 7" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-25
*/


#include <iostream>
#include <cmath>
using namespace std;

int main () {
   int n;

   // Einlesen der Summationsobergrenze n
   cout << "Bitte letzten Index n der Summe eingeben: ";
   cin >> n;

   // sukzessive Bererechung der Summe ueber 2^0 + 2^1 + .. +2^n
   // dabei Vergleich mit der Summe ueber 2^(n+1) - 1
   int sum_left=1, sum_right, i=0;
   while (i < n) {
      // INV: sum_left ist Summe 0..i ueber 2^i
      ++i;
      sum_left = sum_left + int(pow(2,i));
      sum_right = int(pow(2,i+1)) - 1;

     cout << "Differenz bei Berechung der Summe (i = 0 .. " << i << ") ueber 2^i\n"
          << "nach den Formeln 2^0 + .. +2^" << i << endl
          << "und              2^(" << i << "+1) - 1\n"
          << "ist " << sum_left-sum_right << endl << endl;
   }
} 
