/*
Programm: Aufg.kgV-Funktion
Zweck:    Funktion zur Berechnung des kleinsten gemeinsamen Vielfachen
          aus zwei positiven ganzen Zahlen
Aufgabe:  Entspricht dem Punkt "6.6.1 Aufgabe 1" Punkt 5 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-04
*/


#include <iostream>
using namespace std;

int ggT(int a, int b);
int kgV(int a, int b);


int main () {
   int x,
       y;

   // Eingabe
   cout << "1. Zahl: ";
   cin  >> x;
   cout << "2. Zahl: ";
   cin  >> y;

   // Funktionsaufruf und Ausgabe
   if (x>=0 && y>=0) 
      cout << "Das kgV von " << x << " und " << y << " ist " << kgV(x,y) << endl;
   else
      cout << "kgV aus negativen Zahlen nicht berechenbar\n";
}

int kgV(int a, int b) {
   // kgV ist a multipliziert mit den Primfaktoren, die in b, aber nicht in a vorkommen
   //  "   "  b      "        "    "       "         "   " a    "   "     " b     "
   // diese ergeben sich aus b/<gemeinsame_Primfaktoren(a,b)>, d.i. b/ggT(a,b)
   return a * b/ggT(a,b);
}

int ggT(int a, int b) {
   // rekursive Berechnung des ggT ber Heron-Verfahren:
   //          { a          fuer a==b
   // ggT(a,b)={ ggT(a,b-a) fuer b>a
   //          { ggT(a-b,a) fuer b<a
   if (a==b) 
      // Rekursionsende
      return a;
   else 
      if (a>b)
         return ggT(a-b,b);
      else
         return ggT(a,b-a);
}

